fixes
[distro-setup] / btrbk-run
index 2eb53c1e25700c6b7dad52e02a9eaf1bcdab2d2b..92e69679c017dd19c776160fbf7e2fc2edf638c8 100644 (file)
--- a/btrbk-run
+++ b/btrbk-run
@@ -89,8 +89,9 @@ targets=()
 early=false
 cron=false
 fast=false
+kd_spread_maybe=false
 orig_args=("$@")
-temp=$(getopt -l cron,fast,pull-reexec,help 23ceil:m:npqrs:t:vh "$@") || usage 1
+temp=$(getopt -l cron,fast,pull-reexec,help 23ceikl:m:npqrs:t:vh "$@") || usage 1
 eval set -- "$temp"
 while true; do
   case $1 in
@@ -113,6 +114,8 @@ while true; do
     # switch mail-host, no need to repeat the same checks again.
     --fast) fast=true ;;
     -i) incremental_strict=true ;;
+    # note this implies resume
+    -k) kd_spread_maybe=true ;;
     # bytes per second, suffix k m g
     -l) rate_limit=$2; shift ;;
     # Comma separated mountpoints to backup. This has defaults set below.
@@ -145,6 +148,14 @@ while true; do
   shift
 done
 
+if $kd_spread_maybe; then
+  if [[ $1 && $1 != resume ]]; then
+    die "dont pass -k without resume or empty run arg"
+  fi
+  cmd_arg=resume
+fi
+
+
 cmd_arg=${1:-run}
 
 
@@ -180,9 +191,6 @@ if [[ -v targets && $source ]]; then
   die "error: -t and -s are mutually exclusive"
 fi
 
-if $verbose; then
-  printf "$pre options: conf_only=%s\ndry_run=%s\nrate_limit=%s\nverbose=%s\ncmd_arg=%s" "$conf_only" "$dry_run" "$rate_limit" "$verbose" "$cmd_arg"
-fi
 ### end options parsing
 
 # remove path from earlier version of btrbk
@@ -207,7 +215,7 @@ kd_spread=false
 if [[ ! -v targets && ! $source ]]; then
   if $cron; then
     if [[ $HOSTNAME != "$MAIL_HOST" ]]; then
-      if [[ $HOSTNAME == kd && $MAIL_HOST == x3 ]]; then
+      if $kd_spread_maybe && [[ $HOSTNAME == kd && $MAIL_HOST == x3 ]]; then
         if ping -q -c1 -w1 x3.office.fsf.org &>/dev/null; then
           work_host=x3.office.fsf.org
         elif ping -q -c1 -w1 x3wg.b8.nz &>/dev/null; then
@@ -261,21 +269,26 @@ if [[ ! -v targets && ! $source ]]; then
       ;;&
     *)
       if $at_home; then
-        if ! $kd_spread; then
+        if ! $kd_spread && [[ $HOSTNAME != x3 ]]; then
           # main work machine
           if ping -q -c1 -w1 x3.office.fsf.org &>/dev/null; then
             targets+=(x3.office.fsf.org)
+          elif ping -q -c1 -w1 $h.b8.nz &>/dev/null; then
+            # in case we took it home
+            targets+=(x3.b8.nz)
           else
             targets+=(x3wg.b8.nz)
           fi
         fi
-        for h in frodo kd; do
+        # temporarily disabled while doing recovery
+        #        for h in frodo kd; do
+        for h in kd; do
           if [[ $HOSTNAME == "$h" ]]; then
             continue
           fi
           targets+=($h.b8.nz)
         done
-        for h in x2 x3 sy; do
+        for h in x2 sy; do
           if [[ $HOSTNAME == "$h" ]]; then
             continue
           fi
@@ -306,6 +319,11 @@ if [[ ! -v targets && ! $source ]]; then
   esac
 fi
 
+if $verbose; then
+  printf "$pre options: conf_only=%s\ndry_run=%s\nrate_limit=%s\nverbose=%s\ncmd_arg=%s" "$conf_only" "$dry_run" "$rate_limit" "$verbose" "$cmd_arg"
+fi
+
+
 if [[ -v targets ]]; then
   echo "targets: ${targets[*]}"
 fi
@@ -345,6 +363,9 @@ else
           if [[ $HOSTNAME == "$HOST2" ]]; then
             prospective_mps+=(/a /ar /qr /q)
           fi
+          if $kd_spread; then
+            prospective_mps=(/a /ar /o /qr /q)
+          fi
         fi
         # note: put q last just in case its specific retention options were to
         # affect other config sections. I havent tested if that is the case.
@@ -362,10 +383,15 @@ else
   done
 fi
 
+if (( ! ${#mountpoints[@]} )); then
+  die didnt get mountpoint arg and had no defaults
+fi
+
 echo "mountpoints: ${mountpoints[*]}"
 
 ##### end command line parsing ########
 
+# todo: this has a timing problem, since btrbk.timer could activate the service after this check.
 if ! $fast && [[ $source ]]; then
   if [[ $(ssh $source ps --no-headers -o comm 1) == systemd ]]; then
     status=$(ssh $source systemctl is-active btrbk.service) || : # normally returns 3
@@ -434,7 +460,6 @@ else
 
   sshable=()
   sshfail=()
-  min_idle_ms=$((1000 * 60 * 15))
   for h in ${targets[@]}; do
     if $fast || $conf_only; then
       # Use some typical values in this case
@@ -471,15 +496,26 @@ else
       die "error: filesystem on target $h is $percent_used % full"
     fi
 
-    # This is a separate ssh because xprintidle can fail and thats ok.
-    if $cron && idle_ms=$(timeout -s 9 6 ssh $h DISPLAY=:0 xprintidle); then
-      if (( idle_ms < min_idle_ms )); then
-
+    # on sy, xprintidle is resetting every 12 seconds even when not
+    # idle, i dunno why, instead we are checking if the screen is locked,
+    # which is good enough.
+    #
+    # This is a separate ssh because the command can fail and thatis ok.
+    if $cron; then
+      locked=false
+      if lock_info=$(timeout -s 9 6 ssh $h DISPLAY=:0 xscreensaver-command -time); then
+        if [[ $lock_info != *non-blanked* ]]; then
+          locked=true
+        fi
+      else
+        locked=true
+      fi
+      if ! $locked; then
         # Ignore this host. i sometimes use a non-main machine for
         # testing or web browsing, knowing that everything will be wiped
         # by the next backup, but I dont want it to happen as Im using
         # it from cronjob.
-        e "warning: $h: active X session in the last 15 minutes, skipping for now"
+        e "warning: $h: seems to be actively in use, skipping for now"
         continue
       fi
     fi
@@ -659,7 +695,9 @@ done
 if [[ $source ]]; then
   m mount-latest-subvol "${subvols[@]}"
 else
-  m /a/exe/mount-latest-remote ${targets[@]}
+  for tg in ${targets[@]}; do
+    m /a/exe/mount-latest-remote "$tg" "${subvols[@]}" || ret=$?
+  done
 fi
 
 if [[ $ret == 0 ]]; then